/*
*******************************************************************************
**
**  This device driver was created by Applilet2 for 78K0/Kx2
**  8-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002 - 2012
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	Timer_user.c
**  Abstract :	This file implements device driver for Timer module.
**  APIlib :	Applilet2 for 78K0/Kx2 V2.41 [29 Apr. 2008]
**
**  Device :	uPD78F0515_48
**
**  Compiler :	CC78K0
**
**  Creation date:	2012/01/14
**  
*******************************************************************************
*/

#pragma interrupt INTTM000 MD_INTTM000
#pragma interrupt INTTM50 MD_INTTM50
#pragma interrupt INTTM51 MD_INTTM51
/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "Timer.h"
/* Start user code for include definition. Do not edit comment generated here */
/* End user code for include definition. Do not edit comment generated here */
#include "user_define.h"

/*
*******************************************************************************
**  Global define
*******************************************************************************
*/
/* Start user code for global definition. Do not edit comment generated here */
#define SERVO1					P7.0
#define SERVO2					P7.1
#define SERVO3					P7.2

#define SERVO1_LED1				P2.0
#define	SERVO1_LED2				P2.1
#define SERVO2_LED1				P2.2
#define SERVO2_LED2				P2.3
#define SERVO3_LED1				P2.4
#define SERVO3_LED2				P2.5


extern unsigned char	servo1_count;
extern unsigned char	servo1_set[2];
extern unsigned char	servo1_on;
extern unsigned char	servo1_n;

extern unsigned char	servo2_count;
extern unsigned char	servo2_set[2];
extern unsigned char	servo2_on;
extern unsigned char	servo2_n;

extern unsigned char	servo3_count;
extern unsigned char	servo3_set[2];
extern unsigned char	servo3_on;
extern unsigned char	servo3_n;

extern unsigned char	set_count;

/* End user code for global definition. Do not edit comment generated here */


/*
**-----------------------------------------------------------------------------
**
**	Abstract:
**		This function is INTTM000 interrupt service routine.
**
**	Parameters:
**		None
**
**	Returns:
**		None
**
**-----------------------------------------------------------------------------
*/
__interrupt void MD_INTTM000( void )
{
	/* Start user code. Do not edit comment generated here */
	if(servo1_on==0){servo1_on=1;servo1_count=servo1_set[servo1_n];}
	if(servo2_on==0){servo2_on=1;servo2_count=servo2_set[servo2_n];}
	if(servo3_on==0){servo3_on=1;servo3_count=servo3_set[servo3_n];}
	/* End user code. Do not edit comment generated here */
}

/*
**-----------------------------------------------------------------------------
**
**	Abstract:
**		This function is INTTM50 interrupt service routine.
**
**	Parameters:
**		None
**
**	Returns:
**		None
**
**-----------------------------------------------------------------------------
*/
__interrupt void MD_INTTM50( void )
{
	/* Start user code. Do not edit comment generated here */
	if(set_count>0){
		set_count--;
	}	
	/* End user code. Do not edit comment generated here */
}

/*
**-----------------------------------------------------------------------------
**
**	Abstract:
**		This function is INTTM51 interrupt service routine.
**
**	Parameters:
**		None
**
**	Returns:
**		None
**
**-----------------------------------------------------------------------------
*/
__interrupt void MD_INTTM51( void )
{
	/* Start user code. Do not edit comment generated here */
	if(servo1_on==1){
		SERVO1=1;
		if(servo1_count>0){
			servo1_count--;
			if(servo1_count==0){
				SERVO1=0;
				servo1_on=0;
			}
		}
	}

	if(servo2_on==1){
		SERVO2=1;
		if(servo2_count>0){
			servo2_count--;
			if(servo2_count==0){
				SERVO2=0;
				servo2_on=0;
			}
		}
	}

	if(servo3_on==1){
		SERVO3=1;
		if(servo3_count>0){
			servo3_count--;
			if(servo3_count==0){
				SERVO3=0;
				servo3_on=0;
			}
		}
	}

	/* End user code. Do not edit comment generated here */
}

/* Start adding user code. Do not edit comment generated here */
/* End user code adding. Do not edit comment generated here */


