/*
*******************************************************************************
**
**  This device driver was created by Applilet2 for 78K0/Kx2
**  8-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002 - 2011
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	 main.c
**  Abstract :	This file implements main function.
**  APIlib :	Applilet2 for 78K0/Kx2 V2.41 [29 Apr. 2008]
**
**  Device :	uPD78F0515_48
**
**  Compiler :	CC78K0
**
**  Creation date:	2011/12/21
**  
*******************************************************************************
*/

/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "Int.h"
#include "Timer.h"
#include "Port.h"
#include "System.h"
/* Start user code for include definition. Do not edit comment generated here */
/* End user code for include definition. Do not edit comment generated here */
#include "user_define.h"

/*
*******************************************************************************
**  Global define
*******************************************************************************
*/
/* Start user code for global definition. Do not edit comment generated here */
/* End user code for global definition. Do not edit comment generated here */


/*
**-----------------------------------------------------------------------------
**
**	Abstract:
**		This function  implements main function.
**
**	Parameters:
**		None
**
**	Returns:
**		None
**
**-----------------------------------------------------------------------------
*/
#define	KEY_SW1					P1.0
#define	KEY_SW2					P1.1
#define	KEY_SW3					P1.2
#define	KEY_SW4					P1.3
#define	KEY_UP					P1.4
#define	KEY_DOWN				P1.5

#define SERVO1					P7.0
#define SERVO2					P7.1
#define SERVO3					P7.2

#define SERVO1_LED1				P2.0
#define	SERVO1_LED2				P2.1
#define SERVO2_LED1				P2.2
#define SERVO2_LED2				P2.3
#define SERVO3_LED1				P2.4
#define SERVO3_LED2				P2.5

#define	SIG_DATA				P12.2

unsigned char	servo1_count;
unsigned char	servo1_set[2]={10,14};	/* 9msec,13msec*/
unsigned char	servo1_on;
unsigned char	servo1_n;

unsigned char	servo2_count;
unsigned char	servo2_set[2]={10,14};	/* 9msec,13msec*/
unsigned char	servo2_on;
unsigned char	servo2_n;

unsigned char	servo3_count;
unsigned char	servo3_set[2]={10,14};	/* 9msec,13msec*/
unsigned char	servo3_on;
unsigned char	servo3_n;

unsigned char	set_count;
unsigned char	data_ch;


void	wait_time(unsigned int time)
{
	while(time!=0){
		time--;
	}
}

/*---------- signal out ----------*/
void	head_out_sig(void)
{
	set_count=4;
	TM50_Start();SIG_DATA=1;
	while(set_count>0){}
	TM50_Stop();SIG_DATA=0;
	set_count=4;
	TM50_Start();
	while(set_count>0){}
	TM50_Stop();
}
void	data1_out_sig(void)
{
	set_count=1;
	TM50_Start();SIG_DATA=1;
	while(set_count>0){}
	TM50_Stop();SIG_DATA=0;
	set_count=3;
	TM50_Start();
	while(set_count>0){}
	TM50_Stop();
}
void	data0_out_sig(void)
{
	set_count=1;
	TM50_Start();SIG_DATA=1;
	while(set_count>0){}
	TM50_Stop();SIG_DATA=0;
	set_count=1;
	TM50_Start();
	while(set_count>0){}
	TM50_Stop();
}
void	end_out_sig(void)
{
	set_count=1;
	TM50_Start();SIG_DATA=1;
	while(set_count>0){}
	TM50_Stop();SIG_DATA=0;
	set_count=35;
	TM50_Start();
	while(set_count>0){}
	TM50_Stop();
}
void	data8_out_sig(unsigned int data)
{
unsigned int d;
unsigned char i;

	for(i=0;i<8;i++){
		d=data & 0x01;
		if(d==0x01){data1_out_sig();}
		else{data0_out_sig();}
		data=data>>1;
	}
}


/*---------- MAIN ----------*/
void  main( void )
{
unsigned char	sw1_key;
unsigned char	sw1_rep;
unsigned char	sw1_cnt;
unsigned char	sw2_key;
unsigned char	sw2_rep;
unsigned char	sw2_cnt;
unsigned char	sw3_key;
unsigned char	sw3_rep;
unsigned char	sw3_cnt;
unsigned char	sw3_off;
unsigned char	sw4_key;
unsigned char	sw4_rep;
unsigned char	sw4_cnt;
unsigned char	sw5_key;
unsigned char	sw5_rep;
unsigned char	sw5_cnt;
unsigned char	sw6_key;
unsigned char	sw6_rep;
unsigned char	sw6_cnt;


	sw1_key=0;sw1_rep=0;sw1_cnt=0;
	sw2_key=0;sw2_rep=0;sw2_cnt=0;
	sw3_key=0;sw3_rep=0;sw3_cnt=0;
	sw4_key=0;sw4_rep=0;sw4_cnt=0;
	sw5_key=0;sw5_rep=0;sw5_cnt=0;
	sw6_key=0;sw6_rep=0;sw6_cnt=0;
	
	servo1_n=0;SERVO1_LED1=0;SERVO1_LED2=1;
	servo1_count=servo1_set[servo1_n];
	servo1_on=0;

	servo2_n=0;SERVO2_LED1=1;SERVO2_LED2=0;
	servo2_count=servo2_set[servo2_n];
	servo2_on=0;

	servo3_n=0;SERVO3_LED1=0;SERVO3_LED2=1;
	servo3_count=servo3_set[servo3_n];
	servo3_on=0;

	/*TM00_Start();*/
	/*TM51_Start();*/
	

	/* Start user code. Do not edit comment generated here */
	while (1) {
	/* key scan 1 */
		if (KEY_SW1==0){
				sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
			sw1_cnt=0;
		}
		/*------------------*/
		if (KEY_SW2==0){
				sw2_key=0;
		}
		else{
			sw2_key=1;
			sw2_rep=0;
			sw2_cnt=0;
		}
		/*------------------*/
		if (KEY_SW3==0){
				sw3_key=0;
		}
		else{
			sw3_key=1;
			sw3_rep=0;
			sw3_cnt=0;
		}
		/*------------------*/
		if (KEY_SW4==0){
				sw4_key=0;
		}
		else{
			sw4_key=1;
			sw4_rep=0;
			sw4_cnt=0;
		}
		/*------------------*/
		if (KEY_UP==0){
				sw5_key=0;
		}
		else{
			sw5_key=1;
			sw5_rep=0;
			sw5_cnt=0;
		}
		/*------------------*/
		if (KEY_DOWN==0){
				sw6_key=0;
		}
		else{
			sw6_key=1;
			sw6_rep=0;
			sw6_cnt=0;
		}
		/*------------------*/




		wait_time(3000);


	/* key scan 2 */
		if ((KEY_SW1==0)&&(sw1_key==0)){
			sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
			sw1_cnt=0;
		}
		/*------------------*/
		if ((KEY_SW2==0)&&(sw2_key==0)){
			sw2_key=0;
		}
		else{
			sw2_key=1;
			sw2_rep=0;
			sw2_cnt=0;
		}
		/*------------------*/
		if ((KEY_SW3==0)&&(sw3_key==0)){
			sw3_key=0;
		}
		else{
			sw3_key=1;
			sw3_rep=0;
			sw3_cnt=0;
		}
		/*------------------*/
		if ((KEY_SW4==0)&&(sw4_key==0)){
			sw4_key=0;
		}
		else{
			sw4_key=1;
			sw4_rep=0;
			sw4_cnt=0;
		}
		/*------------------*/
		if ((KEY_UP==0)&&(sw5_key==0)){
			sw5_key=0;
		}
		else{
			sw5_key=1;
			sw5_rep=0;
			sw5_cnt=0;
		}
		/*------------------*/
		if ((KEY_DOWN==0)&&(sw6_key==0)){
			sw6_key=0;
		}
		else{
			sw6_key=1;
			sw6_rep=0;
			sw6_cnt=0;
		}
		/*------------------*/


	/* key action */
		if((sw1_key==0)&&(sw1_rep==0)){
			sw1_rep=1;
			switch(servo1_n){
				case 0:	servo1_n=1;SERVO1_LED1=1;SERVO1_LED2=0;
						data_ch=0;head_out_sig();data8_out_sig(data_ch|0x30);end_out_sig();
						break;
				case 1:	servo1_n=0;SERVO1_LED1=0;SERVO1_LED2=1;
						data_ch=0;head_out_sig();data8_out_sig(data_ch|0x31);end_out_sig();
						break;
			}

			sw1_cnt=0;
		}
		/*------------------*/
		if((sw2_key==0)&&(sw2_rep==0)){
			sw2_rep=1;
			switch(servo2_n){
				case 0:	servo2_n=1;SERVO2_LED1=0;SERVO2_LED2=1;
						data_ch=0;head_out_sig();data8_out_sig(data_ch|0x32);end_out_sig();
						break;
				case 1:	servo2_n=0;SERVO2_LED1=1;SERVO2_LED2=0;
						data_ch=0;head_out_sig();data8_out_sig(data_ch|0x33);end_out_sig();
						break;
			}

			sw2_cnt=0;
		}
		/*------------------*/
		if((sw3_key==0)&&(sw3_rep==0)){
			sw3_rep=1;
			switch(servo3_n){
				case 0:	servo3_n=1;SERVO3_LED1=1;SERVO3_LED2=0;
						data_ch=0;head_out_sig();data8_out_sig(data_ch|0x34);end_out_sig();
						break;
				case 1:	servo3_n=0;SERVO3_LED1=0;SERVO3_LED2=1;
						data_ch=0;head_out_sig();data8_out_sig(data_ch|0x35);end_out_sig();
						break;
			}

			sw3_cnt=0;
		}
		/*------------------*/
	
		/*------------------*/
		if((sw5_key==0)&&(sw5_rep==0)){
			sw5_rep=1;
			data_ch=0;head_out_sig();data8_out_sig(data_ch|0x36);end_out_sig();
			sw5_cnt=0;
		}
		/*------------------*/
		if((sw6_key==0)&&(sw6_rep==0)){
			sw6_rep=1;
			data_ch=0;head_out_sig();data8_out_sig(data_ch|0x37);end_out_sig();
			sw6_cnt=0;
		}
		/*------------------*/
	
	
	
		;
	}
	/* End user code. Do not edit comment generated here */
}

/* Start adding user code. Do not edit comment generated here */
/* End user code adding. Do not edit comment generated here */


